org.apache.lucene.search

## Class DocIdSetIterator

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator

- Direct Known Subclasses:
    FieldCacheTermsFilter.FieldCacheTermsFilterDocIdSet.FieldCacheTermsFilterDocIdSetIterator, FilteredDocIdSetIterator, OpenBitSetIterator, Scorer

      public abstract class DocIdSetIterator
      extends java.lang.Object

  This abstract class defines methods to iterate over a set of non-decreasing doc ids. Note that this class assumes it iterates on doc Ids, and therefore `NO_MORE_DOCS` is set to 2147483647 in order to be used as a sentinel object. Implementations of this class are expected to consider `Integer.MAX_VALUE` as an invalid value.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `NO_MORE_DOCS` When returned by `nextDoc()`, `advance(int)` and `doc()` it means there are no more docs in the iterator.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DocIdSetIterator()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `advance(int target)` Advances to the first beyond the current whose document number is greater than or equal to target.
    `int` | `doc()` Deprecated. use `docID()` instead.
    `int` | `docID()` Returns the following: -1 or `NO_MORE_DOCS` if `nextDoc()` or `advance(int)` were not called yet.
    `boolean` | `next()` Deprecated. use `nextDoc()` instead. This will be removed in 3.0
    `int` | `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `NO_MORE_DOCS` if there are no more docs in the set. NOTE: in 3.0 this method will become abstract, following the removal of `next()`.
    `boolean` | `skipTo(int target)` Deprecated. use `advance(int)` instead. This will be removed in 3.0

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NO_MORE_DOCS

          public static final int NO_MORE_DOCS

      When returned by `nextDoc()`, `advance(int)` and `doc()` it means there are no more docs in the iterator.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DocIdSetIterator

          public DocIdSetIterator()

  - ### Method Detail

    - #### doc

          public int doc()

      Deprecated. use `docID()` instead.
      Unsupported anymore. Call `docID()` instead. This method throws `UnsupportedOperationException` if called.

    - #### docID

          public int docID()

      Returns the following:
      - -1 or `NO_MORE_DOCS` if `nextDoc()` or `advance(int)` were not called yet.
      - `NO_MORE_DOCS` if the iterator has exhausted.
      - Otherwise it should return the doc ID it is currently on.

      NOTE: in 3.0, this method will become abstract.

      Since:
        2.9

    - #### next

          public boolean next()
                       throws java.io.IOException

      Deprecated. use `nextDoc()` instead. This will be removed in 3.0
      Unsupported anymore. Call `nextDoc()` instead. This method throws `UnsupportedOperationException` if called.
      Throws:
        `java.io.IOException`

    - #### skipTo

          public boolean skipTo(int target)
                         throws java.io.IOException

      Deprecated. use `advance(int)` instead. This will be removed in 3.0
      Unsupported anymore. Call `advance(int)` instead. This method throws `UnsupportedOperationException` if called.
      Throws:
        `java.io.IOException`

    - #### nextDoc

          public int nextDoc()
                      throws java.io.IOException

      Advances to the next document in the set and returns the doc it is currently on, or `NO_MORE_DOCS` if there are no more docs in the set.
      NOTE: in 3.0 this method will become abstract, following the removal of `next()`. For backward compatibility it is implemented as:

           public int nextDoc() throws IOException {
             return next() ? doc() : NO_MORE_DOCS;
           }

      NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
      Throws:
        `java.io.IOException`
      Since:
        2.9

    - #### advance

          public int advance(int target)
                      throws java.io.IOException

      Advances to the first beyond the current whose document number is greater than or equal to target. Returns the current document number or `NO_MORE_DOCS` if there are no more docs in the set.

      Behaves as if written:

           int advance(int target) {
             int doc;
             while ((doc = nextDoc()) < target) {
             }
             return doc;
           }

      Some implementations are considerably more efficient than that.

      NOTE: certain implementations may return a different value (each time) if called several times in a row with the same target.

      NOTE: this method may be called with 2147483647 for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

      NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

      NOTE: in 3.0 this method will become abstract, following the removal of `skipTo(int)`.

      Throws:
        `java.io.IOException`
      Since:
        2.9

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.